#-*- mode: python; mode: fold -*-
# $Id: __init__.py 452 2006-08-30 12:31:46Z joachim $
from Products.CMFCore.utils import ContentInit, ToolInit
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import utils as cmfutils
from Products.CMFCore.permissions import AddPortalContent

from Products.GenericSetup import profile_registry
from Products.GenericSetup import EXTENSION

from Products.CPSCore.interfaces import ICPSSite

# Only for CPS 3.4.1. In 3.4.2 and later this should be fixed.
import PatchCPSDefaultImportExport
import PatchCatalogToolXMLAdapter

import Products.WAeUP_SRP.WAeUPPermissions

import Widgets

waeup_types = (
    "University.University",
    "Academics.AcademicsFolder",
    "Academics.Certificate",
    "Academics.CertificateCourse",
    "Academics.Faculty",
    "Academics.Department",
    "Academics.Course",
    "Academics.CourseTicket",
    "Academics.CertificateCourse",
    "Accommodation.AccoFolder",
    "Accommodation.Accommodation",
    "Students.StudentsFolder",
    "Students.Student",
    "Students.StudentStudyCourse",
    "Students.StudentAdmission",
    "Students.StudentClearance",
    "Students.StudentPersonal",
    "Students.ScratchCardBatch",
    "Students.ScratchCardBatchesFolder",
    "Students.StudyLevel",
    "Students.Semester",
    )

contentClasses = []
cc = []
for t in waeup_types:
    module,name = t.split('.')
    mod = __import__('Products.WAeUP_SRP.%(module)s' % vars(),
                globals(),
                locals(),
                ["%(name)s" % vars(),"add%(name)s" % vars()]
                )
    contentClasses.append(getattr(mod,name))
    cc.append(getattr(mod,"add%(name)s" % vars()))
    contentConstructors = tuple(cc)

fti = [{} for t in range(len(contentConstructors))]

registerDirectory('skins', globals())

def initialize(registrar):
    ContentInit('WAeUP Types',
                content_types = contentClasses,
                permission = AddPortalContent,
                extra_constructors = contentConstructors,
                fti = fti,
                ).initialize(registrar)

    # Extension profile registration
    profile_registry.registerProfile(
        'default',
        'WAeUP_SRP',
        "The WestAfrican e-University Project",
        'profiles/default',
        'WAeUP_SRP',
        EXTENSION,
        for_=ICPSSite)

